/*
    emndl -- exponentially transformed Mandelbrot Set renderer
    Copyright (C) 2011  Claude Heiland-Allen <claudiusmaximus@goto10.org>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv) {
  if (argc != 2) exit(1);
  int iwidth = atoi(argv[1]);
  int owidth = iwidth >> 1;
  float *iline[2];
  float *oline;
  int ibytes = iwidth * sizeof(float);
  int obytes = owidth * sizeof(float);
  iline[0] = (float *) malloc(ibytes);
  iline[1] = (float *) malloc(ibytes);
  oline    = (float *) malloc(obytes);   
  while ((1 == fread(iline[0], ibytes, 1, stdin)) &&
         (1 == fread(iline[1], ibytes, 1, stdin))) {
    for (int ox = 0; ox < owidth; ++ox) {
      int i = ox << 1;
      int j = i + 1;
      oline[ox] = 0.5 * sqrt(sqrt(iline[0][i])) * sqrt(sqrt(iline[0][j])) * sqrt(sqrt(iline[1][i])) * sqrt(sqrt(iline[1][j]));
//      oline[ox] = fminf(fminf(iline[0][i], iline[0][j]), fminf(iline[1][i], iline[1][j]));
/*
      if (iline[0][i] > 0 && iline[0][j] > 0 && iline[1][i] > 0 && iline[1][j] > 0) {
        oline[ox] = 4/(1/iline[0][i] + 1/iline[0][j] + 1/iline[1][i] + 1/iline[1][j]);
      } else {
        oline[ox] = 0;
      }
*/
    }
    if (fwrite(oline, obytes, 1, stdout) != 1) exit(1);
  }
  free(iline[0]);
  free(iline[1]);
  free(oline);
  return 0;
}
